<!-- Copyright (c) Vincent Dardel, <vindarez@mailz.org>,  Abelujo Developers-->
<!-- See the COPYRIGHT file at the top-level directory of this distribution-->
<!-- Abelujo is free software: you can redistribute it and/or modify-->
<!-- it under the terms of the GNU Affero General Public License as published by-->
<!-- the Free Software Foundation, either version 3 of the License, or-->
<!-- (at your option) any later version.-->
<!-- Abelujo is distributed in the hope that it will be useful,-->
<!-- but WITHOUT ANY WARRANTY; without even the implied warranty of-->
<!-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the-->
<!-- GNU Affero General Public License for more details.-->
<!-- You should have received a copy of the GNU Affero General Public License-->
<!-- along with Abelujo.  If not, see <http://www.gnu.org/licenses/>.-->
{% extends "base.html" %}

<!-- info: html generated from a .jade -->

<!-- Using abelujo-js.js -->

{% block pagetitle %}
{{ title }}
{% endblock %}

{% block content %}
{% load bootstrap3 %}
{% bootstrap_css %}
{% bootstrap_javascript %}
{% load i18n %}
{% load currencyfilter %}
{% load ngfilter %}

<div class="row">
  <div class="col-lg-10">
    <ul class="nav nav-tabs">
      <li class="active", role="presentation">
        <a href="#">
          <h3> {% trans "Reservations" %} ({{ nb_reservations }}) &nbsp;
          </h3>
      </li>
      <li role="presentation">
        <a href="/databasesearch/reservation" target="_blank"> {% trans "History" %} </a>
      </li>
    </ul>
  </div>
</div>

<div style="clear: both;">
  <div style="padding: 1em 0 0 2em;">
    <a class="btn btn-default" href="http://abelujo.cc/docs/clients/" target="_blank" title=''{% trans "Read the documentation" %}'>
      <i class="glyphicon glyphicon-question-sign">
      </i>
    </a>

    <span style="color: grey">
      SMS:
      {% if not FEATURE_SMS %}
      <i class="glyphicon glyphicon-remove"></i>
      {% else %}
      <i class="glyphicon glyphicon-ok"></i>
      {% endif %}
    </span>

  </div>
  <hr>
</div>


<div class="container">

  <div class="row">
    <div class="col-md-4">
      <input id="default-input"
          autofocus
          autocomplete="off"
          class="form-control"
          style="text"
        onkeyup="filterClients()" />
    </div>
  </div>

  {% for client_reservations in reservations %}
  {% with client=client_reservations.0 reservations=client_reservations.1 %}

  <div class="row client-row">
    <div class="col-md-4">
      <h4 id="client-{{ client.pk }}">
        <a href="{{ client.get_absolute_url }}">
          <span class="client-name">
          {{ client }}
          </span>
        </a>
      </h4>

      <div>
        <i class="glyphicon glyphicon-earphone"> </i>
        {% if client.mobilephone %}
        {{ client.mobilephone }}
        {% endif %}

        {% if client.telephone %}
        / {{ client.telephone }}
        {% endif %}

        {% if FEATURE_SMS %}
        <div>
          {% if client.mobilephone_for_sms %}

          {% trans "Send SMS" %}
          <a href="sms:{{ client.mobilephone }}?body={{ client.reservation_sms_body }}">
            <i class="glyphicon glyphicon-earphone" title="{% trans 'Write a SMS to' %}  {{ client}}" style="margin-left: 1em">
            </i>
          </a>

          <button type="button" class="btn btn-default" data-toggle="modal" data-target="#smsModal-client-{{ client.pk }}" style="margin-left: 2em" title="{% trans 'Edit and send the SMS' %}">
            <i class="glyphicon glyphicon-pencil"></i>
          </button>

          {% with last_sms_sent=client.last_sms_sent %}
          {% if last_sms_sent %}
          <div style="color: grey">
            <span>
              {% trans "Last SMS sent" %}: {{ last_sms_sent.created }}
            </span>
            <a class="mouse-pointer" style="color: grey; text-decoration: underline" data-toggle="modal" data-target="#smsHistoryModal-client-{{ client.pk }}">
              {% trans "view" %}
            </a>
          </div>
          {% endif %}
          {% endwith %}

          {% endif %}

        </div>

        {% endif %}

      </div>

      <div>
        {{ client.email }}

        {% if client.email %}
        <a href="mailto:{{ client.email }}?subject={% trans 'Your reservation has arrived' %}&body={{ client.reservation_email_body }}">
          <i class="glyphicon glyphicon-envelope" title="{% trans 'Write to' %}  {{ client}} {% trans ' with your desktop mail client' %}" style="margin-left: 1em">
          </i>
        </a>

        <span data-comment="Same button, in orange: it is a reminder message"></span>

        <a href="mailto:{{ client.email }}?subject={% trans 'Your books are waiting for you' %}&body={{ client.reservation_email_body_reminder }}">
          <i class="glyphicon glyphicon-envelope" title="{% trans 'Write to' %}  {{ client}} {% trans ' with your desktop mail client' %}"
             style="margin-left: 1em; color: orange">
          </i>
        </a>

        <span data-comment="Same button, in red: it is the third and last time."></span>

        {% trans 'your books are still waiting for you' as text_still_waiting %}
        <a href="mailto:{{ client.email }}?subject={% trans 'Reminder:'%} {{ text_still_waiting | lower }}&body={{ client.reservation_email_body_last_reminder }}">
          <i class="glyphicon glyphicon-envelope" title="{% trans 'Write to' %}  {{ client}} {% trans ' with your desktop mail client' %}"
             style="margin-left: 1em; color: red">
          </i>
        </a>
        {% endif %}
      </div>

      <div>
        {% if client.address1 %}
        {{ client.address1 }},

        {% if client.address2 %}
        {{ client.address2 }},
        {% endif %}
        {% if client.zip_code %}
        {{ client.zip_code }}
        {% endif %}
        {% endif %}

        {% if client.city %}
        {{ client.city }}
        {% endif %}
        {% if client.state %}
        {{ client.state }}
        {% endif %}

        {% if client.country %}
        {{ client.country }}
        {% endif %}
      </div>

    </div>

    <div class="col-md-8">
      {% for resa in reservations %}
      <div id="resa-{{ resa.pk }}" class="row">
        <div class="col-md-6">

          <h4>
            <a href="{{ resa.get_absolute_url }}">
              #{{ resa.pk }} 
            </a>
            <a href="{{ resa.card.get_absolute_url }}">

              {{ resa.card.title }}
            </a>
          </h4>

          <div style="clear: both">
            <div style="float: left"> {{ resa.card.pubs_repr }} </div>
            <div  style="color: grey"> &nbsp; {{ resa.card.isbn }} </div>
          </div>

          <div>
            {{ resa.card.price_fmt }}

            {% if resa.card.weight %}
            &nbsp; {{ resa.card.get_weight_repr }}
            {% else %}
            {% trans "⚠ poids inconnu" %}
            {% endif %}
          </div>

        </div>

        <div class="col-md-1">
          {% if resa.nb %}
          x{{ resa.nb }}
          {% else %}
          <!-- In case nb is None, maybe happens in old DB. -->
          x1
          {% endif %}
        </div>

        <div class="col-md-2">
          {% if resa.is_paid %}
          <i style="color: green" class="glyphicon glyphicon-usd" title="Cette commande a déjà été payée ({{ resa.payment_origin }})"> </i>

          {% else %}
          <i style="" class="glyphicon glyphicon-credit-card" title="Cette réservation est à encaiser, elle n'a pas été réglée.
Si elle provient d'une commande en ligne avec tentative d'achat, il est toujours possible que le paiement ait été rejeté et que le client n'aie pas vu le message du prestataire de paiement. En ce cas, vous pouvez vérifier avec votre tableau de bord Stripe."> </i>
          {% endif %}

          {% if resa.send_by_post %}
          <i class="glyphicon glyphicon-gift" title="Cette commande doit être envoyée par colis au client"> </i>
          {% endif %}

          {% if resa.payment_origin %}
          <i class="glyphicon glyphicon-globe" title="Cette commande provient du site web"> </i>
          {% endif %}
        </div>

        <div class="col-md-3">
          {% if resa.is_quite_old %}
          <div style="color: darkorange"> {{ resa.created }} </div>
          {% else %}
          <div> {{ resa.created }} </div>
          {% endif %}
        </div>

        <div class="col-md-1">
          {% if user.is_staff %}
          <a class="btn btn-default"
              id="remove-card-{{ resa.card.pk }}"
              hx-post="/api/card/{{ resa.card.pk }}/cancelreservation/{{ resa.client.pk}}"
              hx-target="#resa-{{ resa.pk }}"
          >
            <i class="glyphicon glyphicon-remove"> </i>
            {% else %}
            <a class="btn btn-default" disabled>
              <i class="glyphicon glyphicon-remove"> </i>
            </a>
            {% endif %}
          </a>
        </div>
      </div>
      {% endfor %}
    </div>
  </div>


  {% endwith %}
  {% endfor %}
</div>

{% for client_reservations in reservations %}
{% with client=client_reservations.0 reservations=client_reservations.1 %}

<!-- Silly? Create HTML code for a modal by reservation, so we can prefill data easily, without JS. -->
  <div class="modal" id="smsModal-client-{{ client.pk }}">
    <div class="modal-dialog">
        <div class="modal-content">

        <!-- Modal Header -->
        <div class="modal-header">
            <h4 class="modal-title"> {% trans "Send SMS to" %} &nbsp; {{ client }}</h4>
            <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>

        <!-- Modal body -->
        <div class="modal-body">
            <h4> {{ client.mobilephone }} </h4>

            <form>
              <textarea id="modal-body-{{ client.pk }}" rows="5" cols="63" spellcheck="default">{{ client.reservation_sms_body }}</textarea>
            </form>

        </div>

        <!-- Modal footer -->
        <div class="modal-footer">
            <button type="button" class="btn btn-danger" data-dismiss="modal">{% trans "Close" %} </button>
            <button type="button" class="btn btn-success" data-dismiss="modal" onclick="sendSMS( {{ client.pk }})">
              {% trans "Send" %}
            </button>
        </div>

        </div>
    </div>
    </div>

<!-- Create another modal to see the last sent SMS to this client. -->
  <div class="modal" id="smsHistoryModal-client-{{ client.pk }}">
    <div class="modal-dialog">
        <div class="modal-content">

        <!-- Modal Header -->
        <div class="modal-header">
          <h4 class="modal-title"> {% trans "Last SMS sent" %}: &nbsp; {{ client }}</h4>
          <div style="color: grey">
            {% trans "total" %}: {{ client.nb_sms_sent }}
          </div>

          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>

        <!-- Modal body -->
        <div class="modal-body">
            <h4> {{ client.mobilephone }} </h4>

            {% for sms in client.recent_sms %}
            <div style="margin-bottom: 1em">
              <span style="color: grey">
                {{ sms.created }}
              </span>
              - {{ sms.body }}
            </div>
            {% endfor %}

        </div>

        <!-- Modal footer -->
        <div class="modal-footer">
            <button type="button" class="btn btn-danger" data-dismiss="modal">{% trans "Close" %} </button>
        </div>

        </div>
    </div>
    </div>

{% endwith %}
{% endfor %}

{% endblock content %}
